;;;********************************************************************
;;;                 
;;;                            KS_OtvK.LSP v.1
;;;                 Copyright,2002        ..
;;;                        AutoCAD 2000 (15)
;;;                               3.07.02
;;;********************************************************************

(defun c:ks_otvk ()
  (setq cmd	(getvar "CMDECHO")
        blm	(getvar "BLIPMODE")
	oldtp	(getvar "celtype")
	oldcl	(getvar "cecolor")
	sosnap	(getvar "osmode")
	nam1	(findfile "support/ks_otv/ks_otvk.dcl")
	dcl_id	(load_dialog nam1)
	case	"or"
	re	"0"
	n_o	3
	d	0
	dr	0
  )

  (if (new_dialog "otvk" dcl_id)
    (progn
      (mode_tile "d1" 1)
      (action_tile "k_o" "(setq n_o1 $value n_o (+ (atoi n_o1) 3))")
      (action_tile "dr1" "(setq dr2 $value dr (atof dr2))")
      (action_tile "vo" "(progn (setq case $value) (votv_ok))")
      (action_tile "d1" "(setq d2 $value d (atof d2))")
      (action_tile "m1" "(setq re $value)")
      (action_tile "accept" "(okey_ok)")
      (action_tile "cancel" "(progn (setq wrong1 0) (done_dialog 0))")
      (action_tile "help" "(abpr_ok)")
      (start_dialog)
      (unload_dialog dcl_id)
    )
    (exit)
  )
  (if (/= wrong1 0) (otris_ok))

  (setvar "cmdecho" cmd)
  (setvar "blipmode" blm)
  (setvar "osmode" sosnap)
  (setq  p1 nil p2 nil dr nil dr2 nil help_ok nil r nil d nil d2 nil 
         cmd nil blm nil oldtp nil oldcl nil sosnap nil
         case nil nam nil nam1 nil re nil
         n_o1 nil n_o nil obj1 nil obj2 nil obj3 nil wrong1 nil
  )
  (princ)
)

;=====    =====

(defun okey_ok ()
  (setq wrong1 1)
  (cond 	
	((and (= case "od") (<= d 0.0))
	 (progn (set_tile "atten" "   ") (setq wrong1 0)))
	((<= dr 0)
	 (progn (set_tile "atten" "     ") (setq wrong1 0)))
  )
  (if (/= wrong1 0) (done_dialog))
)

;=====  =====

(defun votv_ok ()
  (cond
      ((= case "or") (progn (mode_tile "m1" 0) (mode_tile "d1" 1)))
      ((= case "od") (progn (mode_tile "d1" 0) (mode_tile "m1" 1)))
  )
)

;==========

(defun otris_ok ()
  (setq	p1 (getpoint "\n : ")
	p2 (list (car p1) (+ (cadr p1) (/ dr 2)))
  )
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "osmode" 0)
  (cond	((= case "od") (progn (setq d (/ d 2)) (risot_ok)))
	((= case "or") (progn (update_ok) (risro_ok)))
  )
)

;=====   =====

(defun update_ok ()
  (setq	nam	(findfile "support/ks_otv/ks_otv.dat")
 	x	(open nam "r")
	a	(read-line x)
	aa	(read a)
  )
  (cond	((= re "0") (setq r1 (cdr (assoc 'M3 aa))))
	((= re "1") (setq r1 (cdr (assoc 'M4 aa))))
	((= re "2") (setq r1 (cdr (assoc 'M5 aa))))
	((= re "3") (setq r1 (cdr (assoc 'M6 aa))))
	((= re "4") (setq r1 (cdr (assoc 'M8 aa))))
	((= re "5") (setq r1 (cdr (assoc 'M10 aa))))
	((= re "6") (setq r1 (cdr (assoc 'M12 aa))))
	((= re "7") (setq r1 (cdr (assoc 'M16 aa))))
	((= re "8") (setq r1 (cdr (assoc 'M20 aa))))
  )
  (setq r    (atof (car r1))
        d    (atof (cadr r1))
  )
)

;=====  =====

(defun risot_ok ()
  (setvar "celtype" "ACAD_ISO10W100")
  (setvar "cecolor" "red")
  (command "circle" p1 (/ dr 2))
  (command "line" (polar p2 (* pi 0.5) (+ d 3))
	   	  (polar p2 (* pi 1.5) (+ d 3)) "")
  (setq obj2 (entlast))
  (setvar "celtype" oldtp)
  (setvar "cecolor" oldcl)
  (command "circle" p2 d)
  (setq obj1 (entlast))
  (command "array" obj1 obj2 "" "p" p1 n_o 360 "")
)

;=====  =====

(defun risro_ok ()
  (setvar "celtype" "ACAD_ISO10W100")
  (setvar "cecolor" "red")
  (command "circle" p1 (/ dr 2))
  (command "line" (polar p2 (* pi 0.5) (+ (/ d 2) 3))
	   	  (polar p2 (* pi 1.5) (+ (/ d 2) 3)) "")
  (setq obj2 (entlast))
  (setvar "celtype" oldtp)
  (command "arc" (list (car p2) (+ (cadr p2) r)) "_c" p2 "_a" 270)
  (setq obj3 (entlast))
  (setvar "cecolor" oldcl)
  (command "circle" p2 d)
  (setq obj1 (entlast))
  (command "array" obj1 obj2 obj3 "" "p" p1 n_o 360 "")
)

;===== ""=====

(defun abpr_ok ( )
  (setq help_ok
    (list ""
          "                            "
	  ""
	  "      , "
	  "   ."
	  ""
	  "     :  "
	  "         , "
	  "     E-mail: klf02@yandex.ru"
   )
  )
  (if (not (new_dialog "ab_text" DCL_ID)) (exit))
  (start_list "ab_progr")
  (mapcar 'add_list help_ok)
  (end_list)
  (action_tile  "accept" "(done_dialog)")
  (start_dialog)
)